Bug 1076015 - Multicast-based clustering testsuite does not work on JDK 8
Summary: Multicast-based clustering testsuite does not work on JDK 8
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: JBoss Enterprise Application Platform 6
Classification: JBoss
Component: Clustering, Testsuite
Version: 6.3.0
Hardware: Unspecified
OS: Linux
unspecified
high
Target Milestone: DR6
: EAP 6.4.0
Assignee: Radoslav Husar
QA Contact: Jitka Kozana
URL:
Whiteboard: Clustering testsuite
Depends On:
Blocks: java8 1167666
TreeView+ depends on / blocked
 
Reported: 2014-03-13 11:44 UTC by Pavel Jelinek
Modified: 2019-08-19 12:42 UTC (History)
7 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
: 1167666 (view as bug list)
Environment:
OpenJDK1.8, OracleJDK1.8
Last Closed:
Type: Bug


Attachments (Terms of Use)
logs (3.70 MB, application/zip)
2014-03-13 13:05 UTC, Pavel Jelinek
no flags Details


Links
System ID Priority Status Summary Last Updated
JBoss Issue Tracker JGRP-1878 Minor Resolved Multicast discovery does not work on JDK8 2018-02-02 06:54:54 UTC
Red Hat Bugzilla 1164231 None None None Never

Internal Links: 1164231

Description Pavel Jelinek 2014-03-13 11:44:50 UTC
Some clustering tests fail on just this OS JVM combination. 

See: 
https://jenkins.mw.lab.eng.bos.redhat.com/hudson/view/EAP6/view/EAP6-AS-Testsuite/job/eap-60-as-testsuite-RHEL7-matrix-OracleJDK/jdk=java18_default,label_exp=EAP-RHEL7/7/testReport/

Part of standard output for org.jboss.as.test.clustering.cluster.web.ReplicationWebFailoverTestCase(SYNC-tcp).testGracefulSimpleFailover:

[0m[0m04:49:29,137 INFO  [stdout] (http-/10.16.180.51:8080-12) [node-0/web, node-1/web] != [node-0/web], waiting for a view change event...
[0m[31m04:49:44,177 ERROR [org.apache.catalina.core.ContainerBase.[jboss.web].[default-host].[/distributable].[org.jboss.as.test.clustering.ViewChangeListenerServlet]] (http-/10.16.180.51:8080-12) JBWEB000236: Servlet.service() for servlet org.jboss.as.test.clustering.ViewChangeListenerServlet threw exception: java.lang.InterruptedException: Cluster 'web' failed to establish view [node-0/web, node-1/web] within 15000 ms.  Current view is: [node-0/web]
	at org.jboss.as.test.clustering.ViewChangeListenerBean.establishView(ViewChangeListenerBean.java:80) [classes:]

Comment 1 Pavel Jelinek 2014-03-13 13:05:34 UTC
Created attachment 873985 [details]
logs

Comment 2 Pavel Jelinek 2014-03-13 13:08:03 UTC
Other exception in jbossas-clustering-SYNC-tcp-1/standalone/log/server.log :

04:52:17,904 INFO  [org.jboss.modcluster] (ServerService Thread Pool -- 65) MODCLUSTER000002: Initiating mod_cluster shutdown
04:52:17,918 INFO  [org.apache.coyote.http11.Http11NioProtocol] (MSC service thread 1-2) JBWEB003075: Coyote HTTP/1.1 pausing on: http-/10.16.180.50:8180
04:52:17,918 INFO  [org.apache.coyote.http11.Http11NioProtocol] (MSC service thread 1-2) JBWEB003077: Coyote HTTP/1.1 stopping on : http-/10.16.180.50:8180
04:52:17,919 INFO  [org.jboss.as.connector.subsystems.datasources] (MSC service thread 1-2) JBAS010409: Unbound data source [java:jboss/datasources/ExampleDS]
04:52:17,923 ERROR [org.apache.tomcat.util.net] (http-/10.16.180.50:8180-Acceptor) JBWEB003011: Error allocating socket processor: java.util.concurrent.RejectedExecutionException: Task org.apache.tomcat.util.net.NioEndpoint$ChannelProcessor@120c52eb rejected from java.util.concurrent.ThreadPoolExecutor@17fae263[Terminated, pool size = 0, active threads = 0, queued tasks = 0, completed tasks = 0]
	at java.util.concurrent.ThreadPoolExecutor$AbortPolicy.rejectedExecution(ThreadPoolExecutor.java:2047) [rt.jar:1.8.0]
	at java.util.concurrent.ThreadPoolExecutor.reject(ThreadPoolExecutor.java:823) [rt.jar:1.8.0]
	at java.util.concurrent.ThreadPoolExecutor.execute(ThreadPoolExecutor.java:1369) [rt.jar:1.8.0]
	at org.apache.tomcat.util.net.NioEndpoint.processChannel(NioEndpoint.java:453) [jbossweb-7.4.0.Beta4.jar:7.4.0.Beta4]
	at org.apache.tomcat.util.net.NioEndpoint$Acceptor.run(NioEndpoint.java:566) [jbossweb-7.4.0.Beta4.jar:7.4.0.Beta4]
	at java.lang.Thread.run(Thread.java:744) [rt.jar:1.8.0]

Comment 3 Radoslav Husar 2014-03-19 14:21:10 UTC
Please retest with a stable JDK release, you are using slighly old build of JDK (namely 1.8.0-b128).

RejectedExecutionException is unrelated.

Comment 6 Radoslav Husar 2014-03-20 16:25:18 UTC
The builds are still using b128. Please retest with the latest version od JDK 1.8, it makes no sense to test with pre-released versions of JDK.

Comment 7 Bela Ban 2014-03-25 15:41:32 UTC
Do you guys have a box running on RHEL 7 which I could use to test JGroups ? I'm downloading the ISO image of RHEL 7 and will try to run it on VirtualBox...

Comment 10 Radoslav Husar 2014-07-07 09:19:57 UTC
The results are no longer accessible - HTTP Status 404. Please make sure to mark "keep this build forever" if you link it to an issue tracker.

(Nevertheless, I tried to reproduce the issue but the testsuite run correctly on RHEL7/latest Oracle JDK.)

Comment 11 Pavel Jelinek 2014-08-08 08:32:59 UTC
It's still regularly happening. 
See: https://jenkins.mw.lab.eng.bos.redhat.com/hudson/job/eap-6x-as-testsuite-RHEL-matrix-OracleJDK8/jdk=jdk1.8,label_exp=EAP-RHEL7/19/testReport/ for test results and https://jenkins.mw.lab.eng.bos.redhat.com/hudson/job/eap-6x-as-testsuite-RHEL-matrix-OracleJDK8/jdk=jdk1.8,label_exp=EAP-RHEL7/19/artifact/archive.zip for logs.
Both nodes are started but they don't know about each other. 
How do you specify -Dnode0 and -Dnode1 testsuite parameters?

Comment 12 Pavel Jelinek 2014-08-08 08:42:25 UTC
Sometimes this issue occures on RHEL releases as well but only occasionally.
See: https://jenkins.mw.lab.eng.bos.redhat.com/hudson/job/eap-6x-as-testsuite-RHEL-matrix-OracleJDK8-SM/1/jdk=jdk1.8,label_exp=RHEL6%26%26x86_64/testReport/

Comment 13 Petr Kremensky 2014-09-03 13:33:25 UTC
We can see this also with latest jdk
https://jenkins.mw.lab.eng.bos.redhat.com/hudson/job/eap-6x-as-testsuite-RHEL-matrix-OracleJDK8-SM/6/jdk=jdk1.8,label_exp=EAP-RHEL7/testReport/junit/org.jboss.as.test.clustering.cluster.web/

java version "1.8.0_20"
Java(TM) SE Runtime Environment (build 1.8.0_20-b26)
Java HotSpot(TM) Server VM (build 25.20-b23, mixed mode)

Comment 14 Petr Kremensky 2014-09-03 14:23:18 UTC
Try to reproduce with -Dnode0 != -Dnode1 

where (on testing machine: dev136-virt1)
$ echo $MYTESTIP_1 
10.16.180.15
$ echo $MYTESTIP_2
10.16.180.182

JDK8
./integration-tests.sh -Dts.noSmoke -Dts.clust -Dtest=org.jboss.as.test.clustering.cluster.web.* 
tests pass

./integration-tests.sh -Dts.noSmoke -Dts.clust -Dtest=org.jboss.as.test.clustering.cluster.web.* -Dnode0=$MYTESTIP_1 -Dnode1=$MYTESTIP_2
tests fail

JDK7
./integration-tests.sh -Dts.noSmoke -Dts.clust -Dtest=org.jboss.as.test.clustering.cluster.web.* -Dnode0=$MYTESTIP_1 -Dnode1=$MYTESTIP_2
tests pass

Comment 15 Radoslav Husar 2014-09-03 16:34:09 UTC
I can reproduce the problem on a single machine but with different IP bind addresses. 

The problem does not occur on JDK 7 with the same configuration and does not occur if binding to the same address (using port offset).

Investigating.

Comment 16 Radoslav Husar 2014-09-03 16:39:14 UTC
Same problem with OpenJDK8 and OracleJDK8u40.

Comment 17 JBoss JIRA Server 2014-09-16 12:12:22 UTC
Bela Ban <bela@jboss.com> updated the status of jira JGRP-1878 to Resolved

Comment 19 Marek Kopecky 2014-11-13 11:09:48 UTC
Verified on EAP 6.4.0.DR9


Note You need to log in before you can comment on or make changes to this bug.